/*
 *
 * Copyright 2015-2018 Vladimir Bukhtoyarov
 *
 *       Licensed under the Apache License, Version 2.0 (the "License");
 *       you may not use this file except in compliance with the License.
 *       You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 *      Unless required by applicable law or agreed to in writing, software
 *      distributed under the License is distributed on an "AS IS" BASIS,
 *      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *      See the License for the specific language governing permissions and
 *      limitations under the License.
 */

package io.github.bucket4j.mock;

import io.github.bucket4j.TimeMeter;


public class TimeMeterMock implements TimeMeter {

    private long currentTimeNanos;

    public TimeMeterMock() {
        currentTimeNanos = 0;
    }

    public TimeMeterMock(long currentTimeNanos) {
        this.currentTimeNanos = currentTimeNanos;
    }

    public void addTime(long nanos) {
        currentTimeNanos += nanos;
    }

    public void setCurrentTimeNanos(long currentTimeNanos) {
        this.currentTimeNanos = currentTimeNanos;
    }

    public void setCurrentTimeMillis(long currentTimeMillis) {
        this.currentTimeNanos = currentTimeMillis * 1_000_000;
    }

    public void addMillis(long millis) {
        currentTimeNanos += millis * 1_000_000;
    }

    public void setCurrentTimeSeconds(long currentTimeSeconds) {
        this.currentTimeNanos = currentTimeSeconds * 1_000_000_000;
    }

    public void addSeconds(long seconds) {
        currentTimeNanos += seconds * 1_000_000_000;
    }

    @Override
    public long currentTimeNanos() {
        return currentTimeNanos;
    }

    @Override
    public boolean isWallClockBased() {
        return true;
    }

}
